* apt-pkg/algorithms.cc:
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
39cc8228
DK
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
fc89263e
DK
46fi
47if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50fi
51if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54fi
55msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65}
8d876415
DK
66
67runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
8d876415
DK
76}
77aptconfig() { runapt apt-config $*; }
78aptcache() { runapt apt-cache $*; }
79aptget() { runapt apt-get $*; }
80aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 81aptkey() { runapt apt-key $*; }
158fda31
DK
82dpkg() {
83 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
84}
b6b5a542
DK
85aptitude() {
86 if [ -f ./aptconfig.conf ]; then
87 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
88 elif [ -f ../aptconfig.conf ]; then
89 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
90 else
91 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
92 fi
93}
8d876415 94
b720d0bd
DK
95addtrap() {
96 CURRENTTRAP="$CURRENTTRAP $1"
97 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
98}
8d876415
DK
99
100setupenvironment() {
75954ae2 101 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 102 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 103 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 104 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
105 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
106 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 107 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 108 cd $TMPWORKINGDIRECTORY
cd725954 109 mkdir rootdir aptarchive keys
8d876415 110 cd rootdir
b29c3712
DK
111 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
112 mkdir -p var/cache var/lib var/log
cffea9af 113 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 114 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
115 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
116 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
117 else
118 touch var/lib/dpkg/status
119 fi
cd725954 120 touch var/lib/dpkg/available
8d876415
DK
121 mkdir -p usr/lib/apt
122 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
123 cd ..
2c6baa5a 124 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
125 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
126 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 127 fi
4a4ea26c
AM
128 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
129 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
130 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 131 fi
cd725954
DK
132 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
133 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 134 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 135 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
136 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
137 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 138 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
139 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
140 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
141 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
142 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
143 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
144 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 145 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415
DK
146 export LC_ALL=C
147 msgdone "info"
148}
149
150configarchitecture() {
151 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
152 echo "APT::Architecture \"$1\";" > $CONFFILE
153 shift
154 while [ -n "$1" ]; do
155 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
156 shift
157 done
158}
159
75954ae2 160setupsimplenativepackage() {
ce9864a8
DK
161 local NAME="$1"
162 local ARCH="$2"
163 local VERSION="$3"
164 local RELEASE="${4:-unstable}"
165 local DEPENDENCIES="$5"
166 local DESCRIPTION="$6"
b7899b00
DK
167 local SECTION="${7:-others}"
168 local DISTSECTION
169 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
170 DISTSECTION="main"
171 else
172 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
173 fi
ce9864a8
DK
174 local BUILDDIR=incoming/${NAME}-${VERSION}
175 mkdir -p ${BUILDDIR}/debian/source
176 cd ${BUILDDIR}
177 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
178 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
179 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
180
181 * Initial release
182
b7899b00
DK
183 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
184 test -e debian/control || echo "Source: $NAME
185Section: $SECTION
ce9864a8
DK
186Priority: optional
187Maintainer: Joe Sixpack <joe@example.org>
188Build-Depends: debhelper (>= 7)
189Standards-Version: 3.9.1
190
875bcb36
DK
191Package: $NAME" > debian/control
192 if [ "$ARCH" = 'all' ]; then
193 echo "Architecture: all" >> debian/control
194 else
195 echo "Architecture: any" >> debian/control
196 fi
ce9864a8
DK
197 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
198 if [ -z "$DESCRIPTION" ]; then
199 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
200 If you find such a package installed on your system,
201 YOU did something horribly wrong! They are autogenerated
202 und used only by testcases for APT and surf no other propose…" >> debian/control
203 else
204 echo "Description: $DESCRIPTION" >> debian/control
205 fi
b7899b00
DK
206 test -e debian/compat || echo "7" > debian/compat
207 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 208 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
209 cd - > /dev/null
210}
211
212buildsimplenativepackage() {
213 local NAME="$1"
214 local ARCH="$2"
215 local VERSION="$3"
216 local RELEASE="${4:-unstable}"
217 local DEPENDENCIES="$5"
218 local DESCRIPTION="$6"
219 local SECTION="${7:-others}"
220 local DISTSECTION
221 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
222 DISTSECTION="main"
223 else
224 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
225 fi
5a635ee4 226 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 227
18331adf 228 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
229 mkdir -p $BUILDDIR/debian/source
230 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
231 echo "#!/bin/sh
232echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
233
234 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
235 echo "$NAME ($VERSION) $RELEASE; urgency=low
236
237 * Initial release
238
239 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
240 echo "Source: $NAME
241Section: $SECTION
242Priority: optional
243Maintainer: Joe Sixpack <joe@example.org>
244Standards-Version: 3.9.1
245
875bcb36
DK
246Package: $NAME" > ${BUILDDIR}/debian/control
247 if [ "$ARCH" = 'all' ]; then
248 echo "Architecture: all" >> ${BUILDDIR}/debian/control
249 else
250 echo "Architecture: any" >> ${BUILDDIR}/debian/control
251 fi
b761356f
DK
252 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
253 if [ -z "$DESCRIPTION" ]; then
254 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
255 If you find such a package installed on your system,
256 YOU did something horribly wrong! They are autogenerated
257 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
258 else
259 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
260 fi
261 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
262 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
263
264 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
265 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
266 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
875bcb36 267 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$ARCH)
b761356f
DK
268 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
269
5a635ee4
DK
270 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. > /dev/null
271 echo "pool/${NAME}_${VERSION}_${ARCH}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
b761356f 272 for SRC in $SRCS; do
5a635ee4 273 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 274 done
5a635ee4 275 rm -rf "${BUILDDIR}"
b761356f 276 msgdone "info"
75954ae2
DK
277}
278
279buildpackage() {
280 local BUILDDIR=$1
281 local RELEASE=$2
282 local SECTION=$3
283 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
284 cd $BUILDDIR
285 if [ "$ARCH" = "all" ]; then
286 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
287 fi
b7899b00
DK
288 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
289 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 290 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 291 cd - > /dev/null
b7899b00 292 for PKG in $PKGS; do
75954ae2 293 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
294 done
295 for SRC in $SRCS; do
75954ae2 296 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 297 done
cffea9af 298 msgdone "info"
ce9864a8
DK
299}
300
301buildaptarchive() {
ce9864a8
DK
302 if [ -d incoming ]; then
303 buildaptarchivefromincoming $*
304 else
305 buildaptarchivefromfiles $*
306 fi
307}
308
309createaptftparchiveconfig() {
310 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
311 if [ -z "$ARCHS" ]; then
312 # the pool is empty, so we will operate on faked packages - let us use the configured archs
313 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
314 fi
ce9864a8
DK
315 echo -n 'Dir {
316 ArchiveDir "' >> ftparchive.conf
317 echo -n $(readlink -f .) >> ftparchive.conf
318 echo -n '";
319 CacheDir "' >> ftparchive.conf
320 echo -n $(readlink -f ..) >> ftparchive.conf
321 echo -n '";
b7899b00
DK
322 FileListDir "' >> ftparchive.conf
323 echo -n $(readlink -f pool/) >> ftparchive.conf
324 echo -n '";
325};
326Default {
327 Packages::Compress ". gzip bzip2 lzma";
328 Sources::Compress ". gzip bzip2 lzma";
329 Contents::Compress ". gzip bzip2 lzma";
18331adf
DK
330 Translation::Compress ". gzip bzip2 lzma";
331 LongDescription "false";
ce9864a8
DK
332};
333TreeDefault {
334 Directory "pool/";
335 SrcDirectory "pool/";
336};
337APT {
338 FTPArchive {
339 Release {
340 Origin "joesixpack";
341 Label "apttestcases";
342 Suite "unstable";
343 Description "repository with dummy packages";
344 Architectures "' >> ftparchive.conf
345 echo -n "$ARCHS" >> ftparchive.conf
346 echo 'source";
347 };
348 };
349};' >> ftparchive.conf
b7899b00
DK
350 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
351 echo -n 'tree "dists/' >> ftparchive.conf
352 echo -n "$DIST" >> ftparchive.conf
353 echo -n '" {
ce9864a8
DK
354 Architectures "' >> ftparchive.conf
355 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
356 echo -n 'source";
357 FileList "' >> ftparchive.conf
358 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
359 echo -n '";
360 SourceFileList "' >> ftparchive.conf
361 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
362 echo -n '";
363 Sections "' >> ftparchive.conf
364 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
365 echo '";
ce9864a8 366};' >> ftparchive.conf
b7899b00 367 done
ce9864a8
DK
368}
369
370buildaptftparchivedirectorystructure() {
b7899b00
DK
371 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
372 for DIST in $DISTS; do
373 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
374 for SECTION in $SECTIONS; do
375 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
376 for ARCH in $ARCHS; do
377 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
378 done
379 mkdir -p dists/${DIST}/${SECTION}/source
380 mkdir -p dists/${DIST}/${SECTION}/i18n
381 done
ce9864a8 382 done
ce9864a8
DK
383}
384
9b78cda6
DK
385insertpackage() {
386 local RELEASE="$1"
387 local NAME="$2"
388 local ARCH="$3"
389 local VERSION="$4"
390 local DEPENDENCIES="$5"
391 local ARCHS="$ARCH"
392 if [ "$ARCHS" = "all" ]; then
393 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
394 fi
395 for BUILDARCH in $ARCHS; do
396 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
397 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
398 touch aptarchive/dists/${RELEASE}/main/source/Sources
399 local FILE="${PPATH}/Packages"
400 echo "Package: $NAME
401Priority: optional
402Section: other
2c085486 403Installed-Size: 42
9b78cda6
DK
404Maintainer: Joe Sixpack <joe@example.org>
405Architecture: $ARCH
2c085486
DK
406Version: $VERSION
407Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
9b78cda6
DK
408 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
409 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
410 If you find such a package installed on your system,
411 YOU did something horribly wrong! They are autogenerated
412 und used only by testcases for APT and surf no other propose…
413" >> $FILE
414 done
415}
416
ce9864a8 417buildaptarchivefromincoming() {
3cbbda3c 418 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
419 cd aptarchive
420 [ -e pool ] || ln -s ../incoming pool
421 [ -e ftparchive.conf ] || createaptftparchiveconfig
422 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 423 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 424 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
425 cd - > /dev/null
426 msgdone "info"
9b78cda6 427 generatereleasefiles
ce9864a8
DK
428}
429
430buildaptarchivefromfiles() {
3cbbda3c 431 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
432 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
433 msgninfo "\t${line} file… "
434 cat ${line} | gzip > ${line}.gz
435 cat ${line} | bzip2 > ${line}.bz2
436 cat ${line} | lzma > ${line}.lzma
8d876415 437 msgdone "info"
9b78cda6
DK
438 done
439 generatereleasefiles
440}
441
442generatereleasefiles() {
443 msgninfo "\tGenerate Release files… "
fe0f7911 444 local DATE="${1:-now}"
9b78cda6 445 if [ -e aptarchive/dists ]; then
18331adf
DK
446 for dir in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
447 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Patterns::='Translation-*' > $dir/Index
448 done
9b78cda6 449 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
35faae11 450 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
2c085486
DK
451 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
452 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
35faae11
DK
453 sed -i '/^Date: / a\
454NotAutomatic: yes' $dir/Release
455 fi
9b78cda6
DK
456 done
457 else
458 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 459 fi
fe0f7911
DK
460 if [ "$DATE" != "now" ]; then
461 for release in $(find ./aptarchive -name 'Release'); do
462 touch -d "$1" $release
463 done
8d876415 464 fi
b7899b00 465 msgdone "info"
8d876415
DK
466}
467
b7899b00
DK
468setupdistsaptarchive() {
469 local APTARCHIVE=$(readlink -f ./aptarchive)
470 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
471 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
472 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
473 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
474 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
475 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
476 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
477 msgdone "info"
478 done
479}
480
481setupflataptarchive() {
ce9864a8 482 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
483 if [ -f ${APTARCHIVE}/Packages ]; then
484 msgninfo "\tadd deb sources.list line… "
485 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
486 msgdone "info"
487 else
488 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
489 fi
490 if [ -f ${APTARCHIVE}/Sources ]; then
491 msgninfo "\tadd deb-src sources.list line… "
492 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
493 msgdone "info"
494 else
495 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
496 fi
b7899b00
DK
497}
498
499setupaptarchive() {
500 buildaptarchive
501 if [ -e aptarchive/dists ]; then
502 setupdistsaptarchive
503 else
504 setupflataptarchive
505 fi
f213b6ea 506 signreleasefiles
cd725954 507 msgninfo "\tSync APT's cache with the archive… "
8d876415 508 aptget update -qq
cd725954 509 msgdone "info"
8d876415
DK
510}
511
f213b6ea
DK
512signreleasefiles() {
513 local SIGNER="${1:-Joe Sixpack}"
514 msgninfo "\tSign archive with $SIGNER key… "
515 local SECKEYS=""
516 for KEY in $(find keys/ -name '*.sec'); do
517 SECKEYS="$SECKEYS --secret-keyring $KEY"
518 done
519 local PUBKEYS=""
520 for KEY in $(find keys/ -name '*.pub'); do
521 PUBKEYS="$PUBKEYS --keyring $KEY"
522 done
523 for RELEASE in $(find aptarchive/ -name Release); do
524 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 525 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
526 done
527 msgdone "info"
528}
529
530changetowebserver() {
531 if which weborf > /dev/null; then
532 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 533 addtrap "kill $!;"
f213b6ea
DK
534 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
535 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
536 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
537 done
538 return 0
539 fi
540 return 1
541}
542
543checkdiff() {
8d876415
DK
544 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
545 if [ -n "$DIFFTEXT" ]; then
546 echo
547 echo "$DIFFTEXT"
548 return 1
549 else
550 return 0
551 fi
552}
553
75954ae2
DK
554testfileequal() {
555 local FILE="$1"
556 shift
557 msgtest "Test for correctness of file" "$FILE"
558 if [ -z "$*" ]; then
f213b6ea 559 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 560 else
f213b6ea 561 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
562 fi
563}
564
8d876415
DK
565testequal() {
566 local COMPAREFILE=$(mktemp)
b720d0bd 567 addtrap "rm $COMPAREFILE;"
8d876415
DK
568 echo "$1" > $COMPAREFILE
569 shift
570 msgtest "Test for equality of" "$*"
f213b6ea 571 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
572}
573
685625bd
DK
574testequalor2() {
575 local COMPAREFILE1=$(mktemp)
576 local COMPAREFILE2=$(mktemp)
577 local COMPAREAGAINST=$(mktemp)
b720d0bd 578 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
579 echo "$1" > $COMPAREFILE1
580 echo "$2" > $COMPAREFILE2
581 shift 2
582 msgtest "Test for equality OR of" "$*"
583 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
584 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
585 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
586 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
587 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
588 msgfail )
589}
590
8d876415 591testshowvirtual() {
4bec02c2 592 local VIRTUAL="N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
593 local PACKAGE="$1"
594 shift
595 while [ -n "$1" ]; do
596 VIRTUAL="${VIRTUAL}
4bec02c2 597N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
598 PACKAGE="${PACKAGE} $1"
599 shift
600 done
601 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
602 VIRTUAL="${VIRTUAL}
4bec02c2 603N: No packages found"
8d876415 604 local COMPAREFILE=$(mktemp)
b720d0bd 605 addtrap "rm $COMPAREFILE;"
8d876415
DK
606 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
607 eval `apt-config shell ARCH APT::Architecture`
608 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 609 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
610}
611
612testnopackage() {
613 msgtest "Test for non-existent packages" "apt-cache show $*"
614 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
615 if [ -n "$SHOWPKG" ]; then
616 echo
617 echo "$SHOWPKG"
618 msgfail
619 return 1
620 fi
621 msgpass
622}
01a6e24c
DK
623
624testdpkginstalled() {
625 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
87bc1c45
DK
626 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
627 if [ "$PKGS" != $# ]; then
01a6e24c
DK
628 echo $PKGS
629 dpkg -l $* | grep '^[a-z]'
630 msgfail
631 return 1
632 fi
633 msgpass
634}
635
5cf733e1
DK
636testdpkgnotinstalled() {
637 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
87bc1c45 638 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
639 if [ "$PKGS" != 0 ]; then
640 echo
641 dpkg -l $* | grep '^[a-z]'
642 msgfail
643 return 1
644 fi
645 msgpass
646}